import Foundation
import Accelerate

class ImageNode: Node {
    let name: String
    
    init(outputSize: Int, name: String) {
        self.name = name
        
        super.init(inputSize: 0, outputSize: outputSize)
    }
    
    override func roll(env: Env) -> Instance {
        guard let image = env[name] else {
            fatalError("missing image in environment")
        }
        
        guard outputSize == image.count else {
            fatalError("output size mismatch")
        }
        
        let instance = Instance(of: self, from: nil, output: image)
        return instance
    }
}
